--- a/res/res_pjsip_outbound_registration.c	2018-08-09 21:26:44.209593093 +0300
+++ b/res/res_pjsip_outbound_registration.c	2018-10-05 01:52:07.758847641 +0300
@@ -1112,6 +1112,7 @@
 	pjsip_regc_info info;
 	char server_uri[PJSIP_MAX_URL_SIZE];
 	char client_uri[PJSIP_MAX_URL_SIZE];
+	const char *reason = NULL;
 
 	if (response->client_state->status == SIP_REGISTRATION_STOPPED) {
 		ao2_ref(response, -1);
@@ -1234,8 +1235,20 @@
 		}
 	}
 
+        if (response->rdata) {
+                static const pj_str_t str_reason = { "Reason", 6 };
+                pjsip_generic_string_hdr *reason_hdr;
+                pj_str_t reason_value;
+
+                reason_hdr = pjsip_msg_find_hdr_by_name(response->rdata->msg_info.msg, &str_reason, NULL);
+                if (reason_hdr) {
+			pj_strdup_with_null(response->rdata->tp_info.pool, &reason_value, &reason_hdr->hvalue);
+			reason = pj_strbuf(&reason_value);
+                }
+        }
+
 	ast_system_publish_registry("PJSIP", client_uri, server_uri,
-		sip_outbound_registration_status_str(response->client_state->status), NULL);
+		sip_outbound_registration_status_str(response->client_state->status), reason);
 
 	if (response->client_state->destroy) {
 		/* We have a pending deferred destruction to complete now. */
